#lang errortrace racket
(require "hw5-util.rkt")
; Helpful function to call an effectfull function
(define (run-state h effectful-func)
  (eff-state (effectful-func h)))

(define (quote-heap mem)
  (-> heap? list?)
  (quote-hash (heap-data mem) quote-handle (lambda (x) x) symbol<?))

(define (bind effectful-op continuation)
  (lambda (h1)
    ;; allocate x with 1
    (define eff-x (effectful-op h1))
    (define x (eff-result eff-x))
    (define h2 (eff-state eff-x))
    (define new-effectful-op (continuation x))
    (new-effectful-op h2)))

(define-syntax do
  (syntax-rules (<-)
    ; Only one monadic-op, return it
    [(_ mexp) mexp]
    ; A binding operation
    [(_ var <- mexp rest ...) (bind mexp (lambda (var) (do rest ...)))]
    ; No binding operator, just ignore the return value
    [(_ mexp rest ...)        (bind mexp (lambda (_) (do rest ...)))]))

;---------------------------------
#|
def mult():
  x = pop
  y = pop
  push (x * y)
def prog():
  push(2)
  push(5)
  mult() # 2 * 5 = 10
  push(2)
  mult()  # 10 * 2 = 20
|#

#|
(define (num n)
  (lambda (h)
    (heap-alloc h n)))
|#
(define (push n)
  (lambda (s)
    (eff (cons n s) (void))))

(define push-10 (push 10))

#|
(define (push-push n1 n2)
  (lambda (s)
    (eff (cons n2 (cons n1 s)) (void))))
|#

(define (push-push n1 n2)
  (bind (push n1)
    (lambda (x)
      (push n2))))

(define pop
  (lambda (s)
    (eff (rest s) (first s))))


;(run-state (list) (push-push 10 20))

(define (pure x)
  (lambda (s)
    (eff s x)))
; (pure 10)

; Does not change state:
; (run-state (list 1 2) (pure 20))
;((pure 20) (list 1 2))

(define pop-pop-mult
  (bind
    pop
    (lambda (x)
      (bind
        pop
        (lambda (y)
          (pure (* x y)))))))

; (run-state (list 2 3 4) pop-pop-mult)
; (pop-pop-mult (list 2 3 4))

#|
(define mult
  (bind pop-pop-mult
    (lambda (r) ; = x * y
      (push r))))
|#

#|
def mult():
  x = pop
  y = pop
  push (x * y)
|#

#|
(define mult
  (bind pop
    (lambda (x)
      (bind pop
        (lambda (y)
          (push (* x y)))))))
|#

(define mult
  (do
    x <- pop
    y <- pop
    (push (* x y))))

;(run-state (list 2 3) mult)

;(mult (list 2 3 10))

#|
def prog():
  push(2)
  push(5)
  mult() # 2 * 5 = 10
  push(2)
  mult()  # 10 * 2 = 20
|#
#|
(define prog
  (bind (push 2)
    (lambda (r1)
      (bind (push 5)
        (lambda (r2)
          (bind mult
            (lambda (r3)
              (bind (push 2)
                (lambda (r4)
                  mult)))))))))
(run-state (list) prog)
|#

#|
(define (seq op1 op2)
  (lambda (s1)
    (define s2 (eff-state (op1 s1)))
    (op2 s2)))
|#
(define (seq op1 op2)
  (bind op1
    (lambda (r)
      op2)))


;(run-state (list) (seq (push 10) (push 20)))

(define prog
  (seq (push 2)
    (seq (push 5)
        (seq mult
            (seq (push 2)
                mult)))))
; 20
(run-state (list) prog)

; Try to solve it yourself
#|
(define (seq* . l) 'todo)
(define prog
  (seq* (push 2)
        (push 5)
        mult
        (push 2)
        mult))
|#

(run-state (list 2 3) mult)





















;